{***************************************************************
 *
 * Unit Name : MainCalc
 * Purpose   : Win32-bit Calculator
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 ****************************************************************}

Unit MainCalc;

Interface

Uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Buttons,
  ExtCtrls,
  Menus,
  Mask,
  EvalComp;

Type
  TForm1 = Class(TForm)
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    View1: TMenuItem;
    Help1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Standard1: TMenuItem;
    Scientific1: TMenuItem;
    HelpTopics1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    BitBtn14: TBitBtn;
    BitBtn15: TBitBtn;
    BitBtn16: TBitBtn;
    BitBtn17: TBitBtn;
    BitBtn18: TBitBtn;
    BitBtn19: TBitBtn;
    BitBtn20: TBitBtn;
    BitBtn21: TBitBtn;
    BitBtn22: TBitBtn;
    BitBtn23: TBitBtn;
    BitBtn24: TBitBtn;
    BitBtn25: TBitBtn;
    BitBtn26: TBitBtn;
    BitBtn27: TBitBtn;
    Edit2: TEdit;
    OpList: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    MemList: TListBox;
    Procedure AddNumber(Sender: TObject);
    Procedure AddOperator(Sender: TObject);
    Procedure BitBtn1Click(Sender: TObject);
    Procedure Copy1Click(Sender: TObject);
    Procedure Paste1Click(Sender: TObject);
    Procedure BitBtn2Click(Sender: TObject);
    Procedure BitBtn3Click(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure Edit2KeyPress(Sender: TObject; Var Key: char);
    Procedure Standard1Click(Sender: TObject);
    Procedure Scientific1Click(Sender: TObject);
    Procedure BitBtn6Click(Sender: TObject);
    Procedure BitBtn5Click(Sender: TObject);
    Procedure BitBtn4Click(Sender: TObject);
    Procedure BitBtn7Click(Sender: TObject);
    Procedure BitBtn12Click(Sender: TObject);
    Procedure BitBtn22Click(Sender: TObject);
    Procedure BitBtn17Click(Sender: TObject);
    Procedure About1Click(Sender: TObject);
  private
  public
    Function CalcResult: Real;
  End;

Var
  Form1             : TForm1;

Implementation

{$R *.DFM}
//******************* TForm1.AddNumber *************************

Procedure TForm1.AddNumber(Sender: TObject);
Begin
  If Edit2.Text = '0' Then
    Edit2.Text := (Sender As TBitBtn).Caption
  Else
    Edit2.Text := Edit2.Text + (Sender As TBitBtn).Caption;
End;
//******************* TForm1.BitBtn1Click *************************

Procedure TForm1.BitBtn1Click(Sender: TObject);
Begin
  Edit2.Undo;
End;
//******************* TForm1.Copy1Click *************************

Procedure TForm1.Copy1Click(Sender: TObject);
Begin
  Edit2.SelectAll;
  Edit2.CopyToClipboard;
End;
//******************* TForm1.Paste1Click *************************

Procedure TForm1.Paste1Click(Sender: TObject);
Begin
  Edit2.PasteFromClipboard;
End;
//******************* TForm1.BitBtn2Click *************************

Procedure TForm1.BitBtn2Click(Sender: TObject);
Begin
  Edit2.Text := '0';
  If OpList.Items.Count > 0 Then OpList.Items.Delete(OpList.Items.Count - 1);
End;
//******************* TForm1.BitBtn3Click *************************

Procedure TForm1.BitBtn3Click(Sender: TObject);
Begin
  OpList.Clear;
  Label2.Caption := '0';
End;

//******************* TForm1.FormCreate *************************

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  Edit2.Text := '0';
  Width := 258;
End;
//******************* TForm1.AddOperator *************************

Procedure TForm1.AddOperator(Sender: TObject);
Var
  S                 : String;
Begin
  If (OpList.Items.Count > 0) Then
    Begin
      S := OpList.Items.Strings[OpList.Items.Count - 1];
      If (S[Length(S)] = '/') And (StrToFloat(Edit2.Text) = 0) Then Exit;
    End;
  If (Sender As TBitBtn).Caption <> '=' Then
    OpList.Items.Add(Edit2.Text + ' ' + (Sender As TBitBtn).Caption)
  Else
    OpList.Items.Add(Edit2.Text);

  Try
    Label2.Caption := FloatToStr(CalcResult);
  Except
  End;

  If (Sender As TBitBtn).Caption = '=' Then
    Begin
      Edit2.Text := FloatToStr(CalcResult);
      OpList.Clear;
    End
  Else
    Edit2.Text := '0';
End;
//******************* TForm1.CalcResult *************************

Function TForm1.CalcResult: Real;
Var
  calc              : EVALVEC;
  FORMULA           : String;
  I                 : Integer;
Begin
  Formula := '';
  For I := 0 To OpList.Items.Count - 1 Do
    Formula := Formula + Trim(OpList.Items.Strings[I]);
  New(calc, init(FORMULA));
  Result := calc^.eval;
  Dispose(calc, done);
End;
//******************* TForm1.Edit2KeyPress *************************

Procedure TForm1.Edit2KeyPress(Sender: TObject; Var Key: char);
Begin
  If Not (Key In [#8, '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '0', '+', '-', '*', '/', '.']) Then Key := #0;
End;
//******************* TForm1.Standard1Click *************************

Procedure TForm1.Standard1Click(Sender: TObject);
Begin
  Standard1.Checked := True;
  Width := 258;
End;
//******************* TForm1.Scientific1Click *************************

Procedure TForm1.Scientific1Click(Sender: TObject);
Begin
  Scientific1.Checked := True;
  Width := 482;
End;
//******************* TForm1.BitBtn6Click *************************

Procedure TForm1.BitBtn6Click(Sender: TObject);
Begin
  MemList.Items.Add(Edit2.Text);
  Panel1.Caption := 'M';
End;
//******************* TForm1.BitBtn5Click *************************

Procedure TForm1.BitBtn5Click(Sender: TObject);
Begin
  If (MemList.Items.Count > 0) And (MemList.ItemIndex >= 0) Then
    Edit2.Text := MemList.Items.Strings[MemList.ItemIndex];
End;
//******************* TForm1.BitBtn4Click *************************

Procedure TForm1.BitBtn4Click(Sender: TObject);
Begin
  MemList.Clear;
  Panel1.Caption := '';
End;
//******************* TForm1.BitBtn7Click *************************

Procedure TForm1.BitBtn7Click(Sender: TObject);
Begin
  If (MemList.Items.Count > 0) And (MemList.ItemIndex >= 0) Then
    Begin
      BitBtn26.Click;
      Edit2.Text := MemList.Items.Strings[MemList.ItemIndex];
      BitBtn26.Click;
    End;
End;
//******************* TForm1.BitBtn12Click *************************

Procedure TForm1.BitBtn12Click(Sender: TObject);
Begin
  BitBtn27.Click;
  Edit2.Text := FloatToStr(sqrt(StrToFloat(Edit2.Text)));
  Label2.Caption := Edit2.Text;
End;
//******************* TForm1.BitBtn22Click *************************

Procedure TForm1.BitBtn22Click(Sender: TObject);
Begin
  If StrToFloat(Edit2.Text) <> 0 Then
    Begin
      Edit2.Text := FloatToStr(1 / StrToFloat(Edit2.Text));
      Label2.Caption := Edit2.Text;
    End;
End;
//******************* TForm1.BitBtn17Click *************************

Procedure TForm1.BitBtn17Click(Sender: TObject);
Begin
  bitbtn27.Click;
  Edit2.Text := FloatToStr(StrToFloat(Edit2.Text) / 100);
  Label2.Caption := Edit2.Text;
End;
//******************* TForm1.About1Click *************************

Procedure TForm1.About1Click(Sender: TObject);
Begin
  MessageDlg('Calculator'#13#10'Version 1.0'#13#10'Copyright 1999 by Eugen Mihailescu'#13#13#10'All rights reserved.', mtInformation, [mbOK], 0);
End;

End.

